// AutoCompleteWnd.h
// (c) 2003 exeal

#ifndef _AUTO_COMPLETE_WND_H_
#define _AUTO_COMPLETE_WND_H_
#include "..\..\Manah\ListCtrl.h"
#include <string>
#include <list>


namespace Ascension {

class CEditView;

/// P̓
enum WordProperty {
	WP_VARIABLED,		/// ϐ
	WP_PRIVATEVARIABLE,	/// Jϐ
	WP_CONSTANT,		/// 萔
	WP_METHOD,			/// \bh
	WP_PRIVATEMETHOD,	/// J\bh
	WP_PROPERTY,		/// vpeB
	WP_ATTRIBUTE,		/// 
	WP_EVENT,			/// Cxg
	WP_CLASS,			/// NX
	WP_ENUM,			/// 
	WP_TEMPLATE,		/// ev[g
	WP_INTERFACE,		/// C^[tFCX (vgRNX)
	WP_TYPE,			/// ^
};

/// ͌̒P
struct TCandidateWord {
	std::wstring	strName;		/// O
	WordProperty	wordProperty;	/// 
	std::wstring	strComment;		/// 

	/// RXgN^
	TCandidateWord(const std::wstring& strName_, WordProperty wordProperty_, const std::wstring& strComment_)
			: strName(strName_), wordProperty(wordProperty_), strComment(strComment_) {
	}
};

typedef list<TCandidateWord>	CandidateWordList;

// CAutoCompleteWnd class definition
/////////////////////////////////////////////////////////////////////////////

///	͕⊮EBhE
class CAutoCompleteWnd : public Manah::Windows::Controls::CListCtrl {
	// RXgN^
public:
	CAutoCompleteWnd(CEditView* pView);

	// \bh
public:
	void			Complete();
	bool			Create();
	unsigned long	GetWordCount() const;
	void			SetCandidateWords(const CandidateWordList& listWords);
	void			UpdateListCursel();

	// bZ[Wnh
protected:
	LRESULT	DispatchEvent(UINT message, WPARAM wParam, LPARAM lParam);

	// f[^o
private:
	CEditView*			m_pView;
	CandidateWordList	m_listWords;
};

} // namespace Ascension

#endif /* _AUTO_COMPLETE_WND_H_ */

/* [EOF] */